Unit ZP18R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZP18R(NP :Integer; var A :Array of Real; XN :Real; XK :Real;
                var NB :Integer; var NR :Integer; var NA :Integer;
                var RAB :Array of Real; NP1 :Integer; IERR :Integer);

implementation

procedure ZP18R(NP :Integer; var A :Array of Real; XN :Real; XK :Real;
                var NB :Integer; var NR :Integer; var NA :Integer;
                var RAB :Array of Real; NP1 :Integer; IERR :Integer);
var
N,NTERM,M,J,I,IS_,IS1,IS2,ISIGN,K,KS,KS1,KS2,IFOVFL :Integer;
AB,ALPHA,BE,BETA,X,FA,FB,FFA,FFB :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_23;
begin
NB := 0;
NA := 0;
NR := 0;
BE := XN;
AB := XK;
N := NP;
M := N+1;
for I:=1 to M do
 begin
  RAB[0+(I-1)*NP1] := A[I-1];
_1:
 end;
for I:=1 to N do
 begin
  RAB[1+(I-1)*NP1] := (I)*A[I+0];
_2:
 end;
for I:=3 to M do
 begin
  NTERM := N-I+2;
  ALPHA := RAB[(I-3)+(NTERM+1)*NP1]/RAB[(I-2)+(NTERM+0)*NP1];
  BETA := (RAB[(I-3)+(NTERM+0)*NP1]-ALPHA*RAB[(I-2)+(NTERM-1)*NP1])/RAB[(I-1-1)+(
    NTERM+1-1)*NP1];
  RAB[(I-1)+0*NP1] := BETA*RAB[(I-2)+0*NP1]-RAB[(I-3)+0*NP1];
  if ( I-M ) < 0
   then goto _3
   else if ( I-M ) > 0
         then goto _3
         else goto _5;
_3:
  for J:=2 to NTERM do
   begin
    RAB[(I-1)+(J-1)*NP1] := ALPHA*RAB[(I-2)+(J-2)*NP1]+BETA*RAB[(I-2)+(J-1)*NP1]-RAB[(I-3)+(J-1)*NP1];
_4:
   end;
_5:
 end;
X := BE;
IS_ := 1;
_6:
FA := RAB[(M-1)+0*NP1];
ISIGN := 0;
for I:=2 to M do
 begin
  J := N-I+2;
  FB := RAB[(J-1)+(I-1)*NP1];
  K := I-1;
_7:
  FB := FB*X+RAB[(J-1)+(K-1)*NP1];
  K := K-1;
  if ( K ) < 0
   then goto _8
   else if ( K ) > 0
         then goto _7
         else goto _8;
_8:
  if ( FA*FB ) < 0
   then goto _9
   else if ( FA*FB ) > 0
         then goto _10
         else goto _10;
_9:
  ISIGN := ISIGN+1;
_10:
  FA := FB;
_11:
 end;
case IS_ of
 1: goto _12;
 2: goto _13;
end;
_12:
IS1 := ISIGN;
IS_ := 2;
X := AB;
goto _6;
_13:
IS2 := ISIGN;
KS := 1;
_14:
FFA := RAB[(M-1)+0*NP1];
ISIGN := 0;
for I:=2 to M do
 begin
  J := N-I+2;
  FFB := RAB[(J-1)+(I-1)*NP1];
  case KS of
   1: goto _15;
   2: goto _16;
  end;
_15:
  if ( FFA*FFB ) < 0
   then goto _17
   else if ( FFA*FFB ) > 0
         then goto _18
         else goto _18;
_16:
  if ( FFA*FFB ) < 0
   then goto _18
   else if ( FFA*FFB ) > 0
         then goto _17
         else goto _18;
_17:
  ISIGN := ISIGN+1;
_18:
  FFA := FFB;
_19:
 end;
case KS of
 1: goto _20;
 2: goto _21;
end;
_20:
KS1 := ISIGN;
KS := 2;
goto _14;
_21:
KS2 := ISIGN;
NR := Abs(IS1-IS2);
NA := Abs(IS2-KS1);
NB := Abs(IS1-KS2);
_23:
end;

end.
